require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"
import "android.content.*"
import "android.net.Uri"
import "java.io.File"

activity.setTitle("File Sharing Tool. Created by Noman Akbar. ")

layout = {
    LinearLayout,
    orientation = "vertical",
    {
        Button,
        text = "Select and Share Files",
        id = "shareFilesBtn",
        layout_width = "match_parent",
    },
}

activity.setContentView(loadlayout(layout))

function selectFiles()
    local intent = Intent(Intent.ACTION_GET_CONTENT)
    intent.setType("*/*")
    intent.putExtra(Intent.EXTRA_ALLOW_MULTIPLE, true)
    activity.startActivityForResult(intent, 1)
end

function shareFiles(fileUris)
    local intent = Intent(Intent.ACTION_SEND_MULTIPLE)
    intent.setType("*/*")
    intent.putParcelableArrayListExtra(Intent.EXTRA_STREAM, fileUris)
    intent.setFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
    activity.startActivity(Intent.createChooser(intent, "Share Files"))
end

function onActivityResult(requestCode, resultCode, data)
    if requestCode == 1 and resultCode == -1 then
        local fileUris = ArrayList()
        if data.getClipData() then
            for i = 0, data.getClipData().getItemCount() - 1 do
                fileUris.add(data.getClipData().getItemAt(i).getUri())
            end
        elseif data.getData() then
            fileUris.add(data.getData())
        end
        if fileUris.size() > 0 then
            shareFiles(fileUris)
        end
    end
end

shareFilesBtn.onClick = function()
    selectFiles()
end